#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include "vars.h"



int run_make_cache (char *config)
{
 char lock_file[ML_FILE_NAME],etmp[ML_ETMP],tmp[ML_FILE_NAME*2+5];
 struct flock lck;
 int fd;
 
 // Set lock structure
 lck.l_type = F_WRLCK;
 lck.l_whence = 0;
 lck.l_start = 0L;
 lck.l_len = 0L;
			    
 // Set lock file
 sprintf(lock_file,"%s/lock.file",redir[0]->ban_dir);
 #ifdef DEBUG_RUN_MAKE_CACHE
 printf("lock file: %s\n",lock_file);
 #endif
 
 // Open lock file
 fd = open (lock_file, O_RDWR | O_CREAT,0600);
 if (fd < 0) 
    {
     sprintf(etmp,"MAKE-CACHE: ERROR: Can't open file %s: %s\n",lock_file,strerror(errno));
     err_mes(etmp);
    }


    if (fcntl (fd, F_SETLK, &lck)<0)
    {
     // I not first, wait first finished
     err_mes("Waiting for make-cache finished");
     if (fcntl (fd, F_SETLKW, &lck)<0)
     {
      sprintf(etmp,"MAKE-CACHE: ERROR: fcntl return error: %s",strerror(errno));
      err_mes(etmp);
      exit(-1);
     }
     err_mes("Make-cache finished detected, continue");     
     // Unlock
      lck.l_type = F_UNLCK;
      
      if (fcntl (fd, F_SETLK, &lck)<0)
       {
        sprintf(etmp,"MAKE-CACHE: ERROR: fcntl return error: %s",strerror(errno));
        err_mes(etmp);
        exit(-1);
       }

     close (fd);
     return(0);
    }
    else
    {
     // I first, run make cache
       err_mes("Run make-cache");
       sprintf(tmp,"%s %s",makecache,config);
       system(tmp);
//       sleep(1);
      err_mes("Make-cache finished");

     // Unlock
      lck.l_type = F_UNLCK;
      
      if (fcntl (fd, F_SETLK, &lck)<0)
       {
        sprintf(etmp,"MAKE-CACHE: ERROR: fcntl return error: %s",strerror(errno));
        err_mes(etmp);
        exit(-1);
       }

    }
 close(fd);
 return(0);
}
